diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 04610b5b2..6387080f1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -3,7 +3,6 @@ package net.minecraft.core.item;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -12,47 +11,41 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemBed extends Item {
-
+public class ItemBed extends ItemPlaceablePair {
     public ItemBed(@NotNull String name, @NotNull String namespaceId, int id) {
-        super(name, namespaceId, id);
+        super(name, namespaceId, id, Blocks.BED, Blocks.BED);
     }
 
-    @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) return false;
-        TilePosc pos1 = blockPos;
-        if (!world.canPlaceInsideBlock(pos1)) {
-            pos1 = new TilePos(pos1).add(side.direction());
-        }
-        final Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).opposite();
-        final TilePos pos2 = new TilePos(pos1).sub(dir);
-
-        if (!world.canPlaceInsideBlock(pos1) || !world.canPlaceInsideBlock(pos2)) return false;
-        
-        final var bed = Blocks.BED.getLogic();
-        if (!bed.isSupported(world, pos1, Side.BOTTOM)) return false;
-        if (!bed.isSupported(world, pos2, Side.BOTTOM)) return false;
-        
-        if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos1, false, side)) return false;
-        if (!world.canBlockIdBePlacedAt(Blocks.BED.id(), pos2, false, side)) return false;
-        
-        
-        final boolean isPlaced1 = 
-            world.setBlockTypeData(pos1, Blocks.BED, dir.legacyIndex());
-        final boolean isPlaced2 = isPlaced1 &&
-            world.setBlockTypeData(pos2, Blocks.BED, dir.legacyIndex() | BlockLogicBed.IS_HEAD.set(0, 1));
-        if (!isPlaced2) {
-            if (isPlaced1) world.setBlockType(pos1, Blocks.AIR);
-            return false;
-        }
-        selfStack.consumeItem(player);
+    public static @NotNull Direction getDirection(@Nullable Player player, @NotNull Side side) {
+        return (player != null)
+            ? player.getHorizontalPlacementDirection(null).opposite()
+            : (side.isHorizontal()) ? side.direction : Direction.NORTH;
+    }
 
-        world.markBlockNeedsUpdate(pos1);
-        world.markBlockNeedsUpdate(pos2);
-        world.notifyBlocksInCapsuleOfNeighborChange(dir.opposite(), pos1, Blocks.BED);
+    @Override
+    protected @NotNull PlacementResult getPlacement(
+        @NotNull ItemStack selfStack, 
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull PlacementResult result
+    ) {
+        final var dir = getDirection(player, side);
+        result.dataA = result.dataB = dir.legacyIndex();
+        result.dataB = BlockLogicBed.IS_HEAD.set(result.dataB, 1);
+        dir.getOffset(result.offsetB);
+        result.offsetB.mul(-1);
+        return result;
+    }
 
-        world.playBlockSoundEffect(player, pos1.x() + 0.5F, pos1.y() + 0.5F, pos1.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
-        return true;
+    @Override
+    public boolean canPlaceDirectlyAtPosition(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos,
+        @NotNull Side side, double xHit, double yHit
+    ) {
+        final var dir = getDirection(player, side);
+        return 
+            IPlaceable.canPlaceBlockDirectlyAtPosition(blockA, world, blockPos, side) &&
+            IPlaceable.canPlaceBlockDirectlyAtPosition(blockB, world, blockPos.sub(dir, new TilePos()), side);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 2d2785f6e..3dbc3b892 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.tag.Tag;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -18,6 +20,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -29,6 +32,15 @@ import java.util.function.BiConsumer;
 
 public abstract class ItemBucket extends ItemFood implements IItemContainer {
 
+    /**
+     * Resolves the item texture basename for a bucket state (e.g. {@code water} vs {@code waterboiling}).
+     * Return {@code defaultName} to use the state's default texture.
+     */
+    @FunctionalInterface
+    public interface TextureStateName {
+        @NotNull String resolve(@Nullable Entity entity, @Nullable World world, @NotNull ItemStack stack, @NotNull String defaultName);
+    }
+
     public record BucketState(
             String name,
             boolean isEdible,
@@ -38,39 +50,52 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
             @Nullable Tag<Block<?>> pickupTag,
             boolean canPlace,
             @Nullable String soundPath,
-            @Nullable BiConsumer<World, TilePos> placementAction
+            @Nullable BiConsumer<World, TilePosc> placementAction,
+            @Nullable TextureStateName textureStateName
     ) {
 
         /**
          * Constructor for Empty/Placeholder states
          */
         public BucketState(String name) {
-            this(name, false, 0, 0, null, null, false, null, null);
+            this(name, false, 0, 0, null, null, false, null, null, null);
         }
 
         /**
          * Constructor for Food/Edible Buckets (Non-placeable)
          */
         public BucketState(String name, int healAmount, int ticksPerHeal) {
-            this(name, true, healAmount, ticksPerHeal, null, null, false, null, null);
+            this(name, true, healAmount, ticksPerHeal, null, null, false, null, null, null);
         }
         /**
          * Constructor for Fluids
          */
         public BucketState(String name, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath) {
-            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, null);
+            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, null, null);
+        }
+        /**
+         * Constructor for Fluids with a conditional item texture
+         */
+        public BucketState(String name, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath, @Nullable TextureStateName textureStateName) {
+            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, null, textureStateName);
         }
         /**
          * Constructor for Fluids with custom action
          */
-        public BucketState(String name, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath, BiConsumer<World, TilePos> placementAction) {
-            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, placementAction);
+        public BucketState(String name, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath, BiConsumer<World, TilePosc> placementAction) {
+            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, placementAction, null);
+        }
+        /**
+         * Constructor for Fluids with custom action and conditional item texture
+         */
+        public BucketState(String name, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath, BiConsumer<World, TilePosc> placementAction, @Nullable TextureStateName textureStateName) {
+            this(name, false, 0, 0, fluidBlock, pickupTag, true, soundPath, placementAction, textureStateName);
         }
         /**
          * Constructor for Edible and Placeable Buckets
          */
         public BucketState(String name, int healAmount, int ticksPerHeal, Block<?> fluidBlock, Tag<Block<?>> pickupTag, String soundPath) {
-            this(name, true, healAmount, ticksPerHeal, fluidBlock, pickupTag, true, soundPath, null);
+            this(name, true, healAmount, ticksPerHeal, fluidBlock, pickupTag, true, soundPath, null, null);
         }
     }
 
@@ -91,7 +116,8 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
                 "water",
                 Blocks.FLUID_WATER_FLOWING,
                 BlockTags.IS_WATER,
-                "liquid.splash"
+                "liquid.splash",
+                ItemBucket::resolveWaterTextureStateName
         ));
 
         registerState(STATE_LAVA, new BucketState(
@@ -141,6 +167,28 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         return id.value();
     }
 
+    private static @NotNull String resolveWaterTextureStateName(final @Nullable Entity entity, final @Nullable World world, final @NotNull ItemStack stack, final @NotNull String defaultName) {
+        final World context = entity != null ? entity.world : world;
+        if (context != null && context.getWorldType().hasTag(WorldTypeTags.NETHER)) {
+            return "waterboiling";
+        }
+        return defaultName;
+    }
+
+    public static @NotNull String getTextureStateName(final @Nullable Entity entity, final @NotNull ItemStack stack) {
+        return getTextureStateName(entity, entity != null ? entity.world : null, stack);
+    }
+
+    public static @NotNull String getTextureStateName(final @Nullable Entity entity, final @Nullable World world, final @NotNull ItemStack stack) {
+        final NamespaceID stateId = getState(stack);
+        final BucketState state = getBucketState(stateId);
+        final String defaultName = getStateName(stateId);
+        if (state.textureStateName() != null) {
+            return state.textureStateName().resolve(entity, world, stack, defaultName);
+        }
+        return defaultName;
+    }
+
     public static Set<NamespaceID> getRegisteredStateIds() {
         return STATE_REGISTRY.keySet();
     }
@@ -188,49 +236,83 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
     }
 
     @Override
-    public ItemStack onUse(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player) {
-        NamespaceID currentStateId = getState(itemStack);
-        BucketState currentState = getBucketState(currentStateId);
+    public boolean interactsWithFluid(@NotNull ItemStack selfStack) {
+        final NamespaceID currentStateId = getState(selfStack);
+        final BucketState currentState = getBucketState(currentStateId);
+        if (!currentState.canPlace() && currentState.isEdible()) return false;
+        return STATE_EMPTY.equals(currentStateId) || getCharges(selfStack) < this.maxCharges;
+    }
 
-        if (currentState.isEdible() && !currentState.canPlace()) {
-            return handleAirClick(itemStack, world, player);
-        }
+    @Override
+    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
+        if (!super.interactsWithEntity(selfStack, entity)) return false;
+        final NamespaceID currentStateId = getState(selfStack);
+        final BucketState currentState = getBucketState(currentStateId);
+        return currentState.canPlace() || !currentState.isEdible();
+    }
 
-        double reachDistance = player.getGamemode().getBlockReachDistance();
-        HitResult hitResultFluid = player.rayCast(reachDistance, 1f, true, false, false);
+    @Override
+    public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
+        NamespaceID currentStateId = getState(selfStack);
+        BucketState currentState = getBucketState(currentStateId);
 
-        if (hitResultFluid == null) {
-            return handleAirClick(itemStack, world, player);
-        } else if (hitResultFluid instanceof HitResult.Entity) {
-            return handleEntityClick(itemStack, world, player);
-        } else if (hitResultFluid instanceof HitResult.Tile hitTileFluid) {
-            TilePosc tilePos = hitTileFluid.tilePos;
-            boolean isSourceBlock = world.getBlockData(tilePos) == 0;
+        if (currentState.isEdible() && !currentState.canPlace()) return false;
 
-            if (isSourceBlock) {
-                NamespaceID targetStateId = getFluidStateAt(world, tilePos);
+        final int oldSize = selfStack.stackSize;
+        var newStack = handleEntityClick(selfStack, mob.world, player, mob);
+        if (newStack.stackSize <= 0) newStack = null;
 
-                boolean isEmptyScoop = STATE_EMPTY.equals(currentStateId);
-                boolean isRefillScoop = currentStateId.equals(targetStateId) && getCharges(itemStack) < this.maxCharges;
+        final boolean isDifferent = oldSize != newStack.stackSize || newStack != selfStack;
+        if (isDifferent) player.inventory.setItem(player.inventory.getCurrentSlot(), newStack);
 
+        return isDifferent;
+    }
+
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        final NamespaceID currentStateId = getState(selfStack);
+        final BucketState currentState = getBucketState(currentStateId);
+
+        if (currentState.isEdible() && !currentState.canPlace()) return false;
+
+        final int oldSize = selfStack.stackSize;
+        @Nullable ItemStack newStack;
+
+        interact: {
+            if (world.getBlockData(tilePos) == 0) {
+                final NamespaceID targetStateId = getFluidStateAt(world, tilePos);
+    
+                final boolean isEmptyScoop = STATE_EMPTY.equals(currentStateId);
+                final boolean isRefillScoop = !isEmptyScoop &&
+                    currentStateId.equals(targetStateId) && getCharges(selfStack) < this.maxCharges;
+    
                 if (targetStateId != null && (isEmptyScoop || isRefillScoop)) {
-                    return tryPickupFluid(itemStack, world, player, tilePos, targetStateId);
+                    newStack = tryPickupFluid(selfStack, world, player, tilePos, targetStateId);
+                    break interact;
                 }
             }
-
+            
             if (currentState.canPlace()) {
-                NamespaceID aimedFluid = getFluidStateAt(world, tilePos);
-                if (currentStateId.equals(aimedFluid) && getCharges(itemStack) < this.maxCharges) {
-                    return itemStack;
+                final NamespaceID aimedFluid = getFluidStateAt(world, tilePos);
+                if (currentStateId.equals(aimedFluid) && getCharges(selfStack) < this.maxCharges) {
+                    newStack = selfStack;
+                    break interact;
                 }
 
-                HitResult hitResultNoFluid = player.rayCast(reachDistance, 1f, false, false, false);
-                if (hitResultNoFluid instanceof HitResult.Tile hitTileNoFluid) {
-                    return tryPlaceFluid(itemStack, world, player, hitTileNoFluid);
-                }
+                newStack = tryPlaceFluid(selfStack, world, player, tilePos, side);
+                break interact;
             }
+            return false;
         }
 
+        final boolean isDifferent = oldSize != newStack.stackSize || newStack != selfStack;
+        if (isDifferent) player.inventory.setItem(player.inventory.getCurrentSlot(), newStack);
+
+        return isDifferent;
+    }
+
+    @Override
+    public ItemStack onUse(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player) {
         return handleAirClick(itemStack, world, player);
     }
 
@@ -255,50 +337,38 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         }
     }
 
-    protected ItemStack tryPlaceFluid(ItemStack itemStack, World world, Player player, HitResult.Tile hitTile) {
-        TilePos rayCastPos = new TilePos(hitTile.tilePos);
-        if (!world.canMineBlock(player, rayCastPos)) return itemStack;
+    protected ItemStack tryPlaceFluid(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (!world.canMineBlock(player, tilePos)) return itemStack;
+
+        final NamespaceID stateId = getState(itemStack);
+        final BucketState bucketState = getBucketState(stateId);
+        if (bucketState.fluidBlock() == null) return itemStack;
 
-        Block<?> blockAtPos = world.getBlockType(rayCastPos);
+        final var blockAtPos = world.getBlockType(tilePos);
         if (!blockAtPos.hasTag(BlockTags.PLACE_OVERWRITES) && !blockAtPos.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
-            Side side = hitTile.side;
-            rayCastPos.x += side.offsetX();
-            rayCastPos.y += side.offsetY();
-            rayCastPos.z += side.offsetZ();
+            tilePos = tilePos.add(side, new TilePos());
         }
 
-        if (rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) return itemStack;
-
-        if (world.isAirBlock(rayCastPos) || !world.getBlockMaterial(rayCastPos).isSolid()) {
-            NamespaceID stateId = getState(itemStack);
-            BucketState bucketState = getBucketState(stateId);
-
-            if (bucketState.fluidBlock() != null) {
-                if (bucketState.soundPath() != null) {
-                    world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, bucketState.soundPath(), 1f, 1f);
-                }
+        if (!world.canBlockIdBePlacedAt(bucketState.fluidBlock().id(), tilePos, true, side)) return itemStack;
 
-                if (bucketState.placementAction() != null) {
-                    bucketState.placementAction().accept(world, rayCastPos);
-                }
+        if (bucketState.placementAction() != null) bucketState.placementAction().accept(world, tilePos);
 
-                final Block<?> replacedBlock = world.getBlockType(rayCastPos);
-                final int replacedData = world.getBlockData(rayCastPos);
+        final Block<?> replacedBlock = world.getBlockType(tilePos);
+        final int replacedData = world.getBlockData(tilePos);
 
-                world.setBlockTypeNotify(rayCastPos, bucketState.fluidBlock());
+        if (!world.setBlockTypeNotify(tilePos, bucketState.fluidBlock())) return itemStack;
 
-                if (!(replacedBlock == Blocks.AIR)) {
-                    replacedBlock.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, replacedData, null, null);
-                }
+        replacedBlock.dropWithCause(world, EnumDropCause.WORLD, tilePos, replacedData, null, null);
 
-                player.swingItem();
+        if (player.getGamemode().hasBlockConsumption()) {
+            setCharges(itemStack, getCharges(itemStack) - 1);
+            if (getCharges(itemStack) == 0) setState(itemStack, STATE_EMPTY);
+        }
 
-                if (player.getGamemode().hasBlockConsumption()) {
-                    setCharges(itemStack, getCharges(itemStack) - 1);
-                    if (getCharges(itemStack) == 0) setState(itemStack, STATE_EMPTY);
-                }
-            }
+        if (bucketState.soundPath() != null) {
+            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, bucketState.soundPath(), 1f, 1f);
         }
+
         return itemStack;
     }
 
@@ -310,7 +380,7 @@ public abstract class ItemBucket extends ItemFood implements IItemContainer {
         return itemStack;
     }
 
-    protected ItemStack handleEntityClick(ItemStack itemStack, World world, Player player) {
+    protected ItemStack handleEntityClick(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player, @NotNull Entity mob) {
         return handleAirClick(itemStack, world, player);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index c12f48bc1..73777cce1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -18,126 +18,76 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemDoor extends Item {
-    protected final @NotNull Block<? extends BlockLogicDoor> doorBlockBottom;
-    protected final @NotNull Block<? extends BlockLogicDoor> doorBlockTop;
-
+public class ItemDoor extends ItemPlaceablePair {
     public ItemDoor(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<? extends BlockLogicDoor> doorBlockBottom, @NotNull Block<? extends BlockLogicDoor> doorBlockTop) {
-        super(name, namespaceId, id);
-        this.maxStackSize = 64;
-        this.doorBlockBottom = doorBlockBottom;
-        this.doorBlockTop = doorBlockTop;
+        super(name, namespaceId, id, doorBlockBottom, doorBlockTop);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (player == null) return false;
-        if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.direction(), new TilePos());
-        }
-
-        if (!world.canBlockIdBePlacedAt(this.doorBlockBottom.id(), blockPos, false, side)) return false;
-
-        Direction leftDir = player.getHorizontalPlacementDirection(side).rotateY(1);
-        int meta = leftDir.legacyIndex();
-
+    protected @NotNull PlacementResult getPlacement(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit, @NotNull PlacementResult result) {
         final var upperPos = blockPos.up(new TilePos());
 
-        int isSolidBlockLeft = (isSupported(world, blockPos, leftDir, false) ? 1 : 0) + (isSupported(world, upperPos, leftDir, false) ? 1 : 0);
-        int isSolidBlockRight = (isSupported(world, blockPos, leftDir.opposite(), true) ? 1 : 0) + (isSupported(world, upperPos, leftDir.opposite(), true) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockType(blockPos.add(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
-        boolean isDoorRight = world.getBlockType(blockPos.sub(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
-        boolean isMirrored = false;
+        final Direction leftDir;
+        if (player != null) leftDir = player.getHorizontalPlacementDirection(side).rotateY(1);
+        else {
+            var dir = side.direction.opposite();
+            if (!dir.isHorizontal()) dir = Direction.NORTH;
+            leftDir = dir.rotateY(1);
+        }
 
+        final int isSolidBlockLeft =
+            (isSupported(world, blockPos, leftDir, false) ? 1 : 0) +
+            (isSupported(world, upperPos, leftDir, false) ? 1 : 0);
+        final int isSolidBlockRight =
+            (isSupported(world, blockPos, leftDir.opposite(), true) ? 1 : 0) +
+            (isSupported(world, upperPos, leftDir.opposite(), true) ? 1 : 0);
+
+        final var query = new TilePos();
+        final boolean isDoorLeft = 
+            world.getBlockType(blockPos.add(leftDir, query)) == this.blockA ||
+            world.getBlockType(blockPos.add(leftDir, query).up()) == this.blockB;
+        final boolean isDoorRight = 
+            world.getBlockType(blockPos.sub(leftDir, query)) == this.blockA ||
+            world.getBlockType(blockPos.sub(leftDir, query).up()) == this.blockB;
+
+        final boolean isMirrored;
         if (isDoorLeft && !isDoorRight) {
             isMirrored = (world.getBlockData(blockPos.add(leftDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
         } else if (isSolidBlockLeft <= 0 || side.direction() != leftDir.opposite()) {
-            if (isSolidBlockRight > 0 && side.direction() == leftDir) {
-                isMirrored = true;
-            } else if (isSolidBlockRight > isSolidBlockLeft) {
-                isMirrored = true;
-            }
-        }
+            isMirrored = 
+                (isSolidBlockRight > 0 && side.direction() == leftDir) || 
+                (isSolidBlockRight > isSolidBlockLeft);
+        } else isMirrored = false;
+
+        int meta = leftDir.legacyIndex();
         if (isMirrored) {
-            meta = meta - 1 & 0b11;
-            meta |= 0b100;
-            meta |= 0b1000;
+            meta -= 1;
+            meta &= 0b0011;
+            meta |= 0b1100;
         }
         meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
 
-        if (!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
-            return false;
+        if (!((BlockLogicDoor)this.blockA.getLogic()).canPlaceAt(world, blockPos, meta)) {
+            result.cannotPlace = true;
+            return result;
         }
 
-        world.setBlockTypeData(blockPos, this.doorBlockBottom, meta);
-        world.setBlockTypeData(upperPos, this.doorBlockTop, meta);
-        selfStack.consumeItem(player);
-
-        this.doorBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-        this.doorBlockTop.onPlacedByMob(world, upperPos, side, player, xHit, yHit);
-
-        // this is technically incorrect as both positions are updated as bottom door,
-        // but does it really matter?
-        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.doorBlockBottom);
-        world.markBlockNeedsUpdate(blockPos);
-        world.markBlockNeedsUpdate(upperPos);
-
-        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
-        return true;
+        result.dataA = result.dataB = meta;
+        result.offsetB.set(0, 1, 0);
+        return result;
     }
 
     public boolean isSupported(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, boolean mirrored) {
-        ISupport support = world.getSupport(tilePos.add(direction, new TilePos()), direction.opposite().side());
-        return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.side());
+        return world
+            .getSupport(tilePos.add(direction, new TilePos()), direction.opposite().side())
+            .canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.side());
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(direction, new TilePos());
-        }
-
-        if (!direction.isHorizontal()) direction = Direction.NORTH;
-        Direction lefDir = direction.rotateY(1);
-        int meta = lefDir.legacyIndex();
-
-        int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir, false) ? 1 : 0);
-        int isSolidBlockRight = (isSupported(world, blockPos, lefDir.opposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.opposite(), true) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockType(blockPos.add(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
-        boolean isDoorRight = world.getBlockType(blockPos.sub(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
-        boolean isMirrored = false;
-
-        if (isDoorLeft && !isDoorRight) {
-            isMirrored = (world.getBlockData(blockPos.add(lefDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
-        } else if (isSolidBlockLeft <= 0 || direction != lefDir.opposite()) {
-            if (isSolidBlockRight > 0 && direction == lefDir) {
-                isMirrored = true;
-            } else if (isSolidBlockRight > isSolidBlockLeft) {
-                isMirrored = true;
-            }
-        }
-        if (isMirrored) {
-            meta = meta - 1 & 0b11;
-            meta |= 0b100;
-            meta |= 0b1000;
-        }
-        meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
-        if (!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
-            return;
-        }
-
-        world.setBlockTypeData(blockPos, this.doorBlockBottom, meta);
-        world.setBlockTypeData(blockPos.up(new TilePos()), this.doorBlockTop, meta);
-        world.markBlockNeedsUpdate(blockPos);
-        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
-
-        selfStack.consumeItem(null);
-
-        this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.side(), 0.5, 0.5);
-        this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.side(), 0.5, 0.5);
-
-        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.doorBlockBottom);
-        
-        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+    public boolean canPlaceDirectlyAtPosition(@NotNull ItemStack selfStack, @NotNull World world,
+            @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        return 
+            IPlaceable.canPlaceBlockDirectlyAtPosition(this.blockA, world, blockPos, side) &&
+            IPlaceable.canPlaceBlockDirectlyAtPosition(this.blockA, world, blockPos, side);
     }
 }
